Package javax.help

# Interface HelpBroker

All Known Implementing Classes:
  `DefaultHelpBroker`, `ServletHelpBroker`

public interface HelpBroker
The HelpBroker is the default presentation of a HelpSet. A HelpBroker is an abstraction of the presentation for a HelpSet; a straight-forward implementation is a JHelp() on the HelpSet. A HelpBroker can be asked to show a given Navigational View, and can display a given ID (help topic).

See Also:
  - `HelpSet`
  - `JHelpNavigator`
  - invalid reference

        javax.help.HelpVisitListener

## Method Summary

Modifier and Type
Method
Description
`void`
`enableHelp(Component comp, String id, HelpSet hs)`
Enables help for a component.
`void`
`enableHelp(MenuItem comp, String id, HelpSet hs)`
Enables help for a MenuItem.
`void`
`enableHelpKey(Component comp, String id, HelpSet hs)`
Enables the Help key on a component.
`void`
`enableHelpKey(Component comp, String id, HelpSet hs, String presentation, String presentationName)`
Enables the Help key on a component.
`void`
`enableHelpOnButton(Component comp, String id, HelpSet hs)`
Enables help for a component.
`void`
`enableHelpOnButton(MenuItem comp, String id, HelpSet hs)`
Enables help for a MenuItem.
`void`
`enableHelpOnButton(Object obj, String id, HelpSet hs, String presentation, String presentationName)`
Enables help for an object.
`Map.ID`
`getCurrentID()`
Determines The currently displayed ID (if any).
`URL`
`getCurrentURL()`
Determines the currently displayed ID.
`String`
`getCurrentView()`
Gets name of the current navigational view.
`Font`
`getFont()`
Gets the font for this HelpBroker.
`HelpSet`
`getHelpSet()`
Gets the current HelpSet for this JavaHelp object.
`Locale`
`getLocale()`
Returns the locale of this object.
`Point`
`getLocation()`
Gets the location of the presentation.
`int`
`getScreen()`
Get ths the screen the presentation is displayed on This operation may throw an UnsupportedOperationException if the underlying implementation does not allow this.
`Dimension`
`getSize()`
Gets the size of the presentation.
`void`
`initPresentation()`
Initializes the presentation.
`boolean`
`isDisplayed()`
Determines if the presentation is visible.
`boolean`
`isViewDisplayed()`
Determines if the Navigational View is visible.
`void`
`setCurrentID(String id)`
Displays this ID.
`void`
`setCurrentID(Map.ID id)`
Displays this ID.
`void`
`setCurrentURL(URL url)`
Displays this ID.
`void`
`setCurrentView(String name)`
Activates the Navigator view with a given name.
`void`
`setDisplayed(boolean displayed)`
Displays the presentation to the user.
`void`
`setFont(Font f)`
Sets the font for this HelpBroker.
`void`
`setHelpSet(HelpSet hs)`
Sets the current HelpSet for this HelpBroker.
`void`
`setHelpSetPresentation(HelpSet.Presentation hsPres)`
Sets the presentation attributes from a HelpSet.Presentation.
`void`
`setLocale(Locale l)`
Sets the locale of this HelpBroker.
`void`
`setLocation(Point p)`
Sets the position of the presentation.
`void`
`setScreen(int screen)`
Set the screen the presentation is to be displayed on This operation may throw an UnsupportedOperationException if the underlying implementation does not allow this.
`void`
`setSize(Dimension d)`
Sets the size of the presentation.
`void`
`setViewDisplayed(boolean displayed)`
Hides/Shows Navigational Views.
`void`
`showID(String id, String presentation, String presentationName)`
Displays this ID in a particular presentation
`void`
`showID(Map.ID id, String presentation, String presentationName)`
Displays this ID in a given presentation

## Method Details

### setHelpSet

void setHelpSet(HelpSet hs)
Sets the current HelpSet for this HelpBroker.

Parameters:
  `hs` - The HelpSet this JavaHelp is presenting.

### getHelpSet

HelpSet getHelpSet()
Gets the current HelpSet for this JavaHelp object.

Returns:
  The HelpSet this JavaHelp is presenting.

### setHelpSetPresentation

void setHelpSetPresentation(HelpSet.Presentation hsPres)
Sets the presentation attributes from a HelpSet.Presentation. The HelpSet.Presentation must be in the current HelpSet.

Parameters:
  `hsPres` - The HelpSet.Presentation
Since:
  2.0

### getLocale

Locale getLocale()
Returns the locale of this object.

Returns:
  The locale of this object.

### setLocale

void setLocale(Locale l)
Sets the locale of this HelpBroker.

Parameters:
  `l` - The locale to become this component's locale.
See Also:
  - `getLocale()`

### getFont

Font getFont()
Gets the font for this HelpBroker.

### setFont

void setFont(Font f)
Sets the font for this HelpBroker.

### setCurrentView

void setCurrentView(String name)
Activates the Navigator view with a given name.

Throws:
  `IllegalArgumentException` - if the name is not valid.

### getCurrentView

String getCurrentView()
Gets name of the current navigational view.

Returns:
  The name of the current navigational view.

### initPresentation

void initPresentation()
Initializes the presentation. This method allows the presentation to be initialized but not displayed. Typically this is done in a separate thread to reduce the intialization time.

### setDisplayed

void setDisplayed(boolean displayed) throws UnsupportedOperationException
Displays the presentation to the user.

Parameters:
  `displayed` - Makes the presentation visible or not.

### isDisplayed

boolean isDisplayed()
Determines if the presentation is visible.

Returns:
  Whether the presentation is currently visible.

### setLocation

void setLocation(Point p) throws UnsupportedOperationException
Sets the position of the presentation. This operation may throw an UnsupportedOperationException if the underlying implementation does not allow this.

Throws:
  `UnsupportedOperationException`

### getLocation

Point getLocation() throws UnsupportedOperationException
Gets the location of the presentation. This operation may throw an UnsupportedOperationException if the underlying implementation does not allow this.

Throws:
  `UnsupportedOperationException`

### setSize

void setSize(Dimension d) throws UnsupportedOperationException
Sets the size of the presentation. This operation may throw an UnsupportedOperationException if the underlying implementation does not allow this.

Throws:
  `UnsupportedOperationException`

### getSize

Dimension getSize() throws UnsupportedOperationException
Gets the size of the presentation. This operation may throw an UnsupportedOperationException if the underlying implementation does not allow this.

Throws:
  `UnsupportedOperationException`

### setScreen

void setScreen(int screen) throws UnsupportedOperationException
Set the screen the presentation is to be displayed on This operation may throw an UnsupportedOperationException if the underlying implementation does not allow this.

Throws:
  `UnsupportedOperationException`

### getScreen

int getScreen() throws UnsupportedOperationException
Get ths the screen the presentation is displayed on This operation may throw an UnsupportedOperationException if the underlying implementation does not allow this.

Throws:
  `UnsupportedOperationException`

### setViewDisplayed

void setViewDisplayed(boolean displayed)
Hides/Shows Navigational Views.

Parameters:
  `displayed` - Make the navigational views visible or not.

### isViewDisplayed

boolean isViewDisplayed()
Determines if the Navigational View is visible.

Returns:
  Whether the navigational views are visible.

### showID

void showID(Map.ID id, String presentation, String presentationName) throws InvalidHelpSetContextException
Displays this ID in a given presentation

Parameters:
  `id` - An ID that identifies the topic to display.
  `presentation` - The Presentation class to display the Help in.
  `presentationName` - The name of a Presentation section from a HelpSet to use. For some Presentations this will also be the name to apply to the Presentation.
Throws:
  `InvalidHelpSetContextException` - If id.hs is not contanied in the current HelpSet of this broker.
See Also:
  - `Presentation`

### showID

void showID(String id, String presentation, String presentationName) throws BadIDException
Displays this ID in a particular presentation

Parameters:
  `id` - A String identifying the topic to show relative to getHelpSet()
  `presentation` - The Presentation class to display the Help in.
  `presentationName` - The name of a Presentation section from a HelpSet to use. For some Presentations this will also be the name to apply to the Presentation.
Throws:
  `BadIDException` - if the ID is not valid in the map.
See Also:
  - `Presentation`

### setCurrentID

void setCurrentID(Map.ID id) throws InvalidHelpSetContextException
Displays this ID.

Parameters:
  `id` - An ID that identifies the topic to display.
Throws:
  `InvalidHelpSetContextException` - If id.hs is not contanied in the current HelpSet of this broker.
See Also:
  - `HelpModel.setCurrentID(javax.help.Map.ID)`

### setCurrentID

void setCurrentID(String id) throws BadIDException
Displays this ID. HelpVisitListeners are notified.

Parameters:
  `id` - A String identifying the topic to show relative to getHelpSet()
Throws:
  `BadIDException` - if the ID is not valid in the map.

### getCurrentID

Map.ID getCurrentID()
Determines The currently displayed ID (if any).

Returns:
  The ID being shown.

### setCurrentURL

void setCurrentURL(URL url)
Displays this ID. HelpVisitListeners are notified. The currentID changes if there is a matching ID for this URL.

Parameters:
  `url` - The URL to show

### getCurrentURL

URL getCurrentURL()
Determines the currently displayed ID.

Returns:
  The URL being shown.

### enableHelpKey

void enableHelpKey(Component comp, String id, HelpSet hs)
Enables the Help key on a component. This method works best when the component is the rootPane of a JFrame in Swing implementations, or a java.awt.Window (or subclass thereof) in AWT implementations. This method sets the default helpID and HelpSet for the component and registers keyboard actions to trap the "Help" keypress. When the "Help" key is pressed, if the object with the current focus has a helpID, the helpID is displayed, otherwise the default helpID is displayed.

Parameters:
  `comp` - The component to enable the keyboard actions on.
  `id` - The default HelpID to be displayed.
  `hs` - The default HelpSet to be displayed.

### enableHelpKey

void enableHelpKey(Component comp, String id, HelpSet hs, String presentation, String presentationName)
Enables the Help key on a component. This method works best when the component is the rootPane of a JFrame in Swing implementations, or a java.awt.Window (or subclass thereof) in AWT implementations. This method sets the default helpID and HelpSet for the component and registers keyboard actions to trap the "Help" keypress. When the "Help" key is pressed, if the object with the current focus has a helpID, the helpID is displayed, otherwise the default helpID is displayed.

Parameters:
  `comp` - The component to enable the keyboard actions on.
  `id` - The default HelpID to be displayed.
  `hs` - The default HelpSet to be displayed.
  `presentation` - The Presentation class to display the Help in.
  `presentationName` - The name of a Presentation section from a HelpSet to use. For some Presentations this will also be the name to apply to the Presentation.
See Also:
  - `Presentation`

### enableHelp

void enableHelp(Component comp, String id, HelpSet hs)
Enables help for a component. This method sets a component's helpID and HelpSet.

See Also:
  - invalid reference

        CSH.setHelpID

  - invalid reference

        CSH.setHelpSet

### enableHelp

void enableHelp(MenuItem comp, String id, HelpSet hs)
Enables help for a MenuItem. This method sets a component's helpID and HelpSet.

See Also:
  - invalid reference

        CSH.setHelpID

  - invalid reference

        CSH.setHelpSet

### enableHelpOnButton

void enableHelpOnButton(Component comp, String id, HelpSet hs) throws IllegalArgumentException
Enables help for a component. This method sets a component's helpID and HelpSet and adds an ActionListener. When an action is performed it displays the component's helpID and HelpSet in the default viewer. If the component is not a javax.swing.AbstractButton or a java.awt.Button an IllegalArgumentException is thrown.

Throws:
  `IllegalArgumentException`
See Also:
  - invalid reference

        CSH.setHelpID

  - invalid reference

        CSH.setHelpSet

  - `AbstractButton`
  - `Button`

### enableHelpOnButton

void enableHelpOnButton(MenuItem comp, String id, HelpSet hs)
Enables help for a MenuItem. This method sets a component's helpID and HelpSet and adds an ActionListener. When an action is performed it displays the component's helpID and HelpSet in the default viewer.

See Also:
  - invalid reference

        CSH.setHelpID

  - invalid reference

        CSH.setHelpSet

  - `MenuItem`

### enableHelpOnButton

void enableHelpOnButton(Object obj, String id, HelpSet hs, String presentation, String presentationName) throws IllegalArgumentException
Enables help for an object. This method sets a object's helpID and HelpSet and adds an ActionListener. When an action is performed it displays the component's helpID and HelpSet in the default viewer or the presenation if defined. If the component is not a javax.swing.AbstractButton or a java.awt.Button an IllegalArgumentException is thrown.

Parameters:
  `id` - The default HelpID to be displayed.
  `hs` - The default HelpSet to be displayed.
  `presentation` - The Presentation class to display the Help in.
  `presentationName` - The name of a Presentation section from a HelpSet to use. For some Presentations this will also be the name to apply to the Presentation.
  `comp` - The component to enable the keyboard actions on.
Throws:
  `IllegalArgumentException`
See Also:
  - `Presentation`
  - invalid reference

        CSH.setHelpID

  - invalid reference

        CSH.setHelpSet

  - `AbstractButton`
  - `Button`